# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_updateservicesapprovalrule`](#dsc_updateservicesapprovalrule): The DSC UpdateServicesApprovalRule resource type. Automatically generated from version 1.2.1
* [`dsc_updateservicescleanup`](#dsc_updateservicescleanup): The DSC UpdateServicesCleanup resource type. Automatically generated from version 1.2.1
* [`dsc_updateservicesserver`](#dsc_updateservicesserver): The DSC UpdateServicesServer resource type. Automatically generated from version 1.2.1

## Resource types

### <a name="dsc_updateservicesapprovalrule"></a>`dsc_updateservicesapprovalrule`

The DSC UpdateServicesApprovalRule resource type.
Automatically generated from version 1.2.1

#### Properties

The following properties are available in the `dsc_updateservicesapprovalrule` type.

##### `dsc_classifications`

Data type: `Optional[Array[String]]`

Classifications in the approval rule.

##### `dsc_computergroups`

Data type: `Optional[Array[String]]`

Computer groups the approval rule applies to.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Whether the approval rule is enabled.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

An enumerated value that describes if WSUS is configured. Present {default}   Absent    

##### `dsc_products`

Data type: `Optional[Array[String]]`

Products in the approval rule.

##### `dsc_runrulenow`

Data type: `Optional[Boolean]`

Run the approval rule after it has been created.

##### `dsc_synchronize`

Data type: `Optional[Boolean]`

Synchronize after creating or updating the approval rule.

#### Parameters

The following parameters are available in the `dsc_updateservicesapprovalrule` type.

* [`dsc_name`](#-dsc_updateservicesapprovalrule--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_updateservicesapprovalrule--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_updateservicesapprovalrule--dsc_timeout)
* [`name`](#-dsc_updateservicesapprovalrule--name)
* [`validation_mode`](#-dsc_updateservicesapprovalrule--validation_mode)

##### <a name="-dsc_updateservicesapprovalrule--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the approval rule.

##### <a name="-dsc_updateservicesapprovalrule--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_updateservicesapprovalrule--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_updateservicesapprovalrule--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_updateservicesapprovalrule--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_updateservicescleanup"></a>`dsc_updateservicescleanup`

The DSC UpdateServicesCleanup resource type.
Automatically generated from version 1.2.1

#### Properties

The following properties are available in the `dsc_updateservicescleanup` type.

##### `dsc_cleanuplocalpublishedcontentfiles`

Data type: `Optional[Boolean]`

Cleanup local published content files.

##### `dsc_cleanupobsoletecomputers`

Data type: `Optional[Boolean]`

Delete computers that have not contacted the server in 30 days or more.

##### `dsc_cleanupobsoleteupdates`

Data type: `Optional[Boolean]`

Delete updates that are expired and have not been approved for 30 days or more, and delete older update revisions that have not been approved for 30 days or more.

##### `dsc_cleanupunneededcontentfiles`

Data type: `Optional[Boolean]`

Delete update files that aren't needed by updates or downstream servers.

##### `dsc_compressupdates`

Data type: `Optional[Boolean]`

Compress updates.

##### `dsc_declineexpiredupdates`

Data type: `Optional[Boolean]`

Decline updates that aren't approved and have been expired by Microsoft.

##### `dsc_declinesupersededupdates`

Data type: `Optional[Boolean]`

Decline updates that have not been approved fo 30 days or more, are not currently needed by any clients, and are superseded by an approved update.

##### `dsc_timeofday`

Data type: `Optional[String]`

Time of day to start cleanup.

#### Parameters

The following parameters are available in the `dsc_updateservicescleanup` type.

* [`dsc_ensure`](#-dsc_updateservicescleanup--dsc_ensure)
* [`dsc_psdscrunascredential`](#-dsc_updateservicescleanup--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_updateservicescleanup--dsc_timeout)
* [`name`](#-dsc_updateservicescleanup--name)
* [`validation_mode`](#-dsc_updateservicescleanup--validation_mode)

##### <a name="-dsc_updateservicescleanup--dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'present', 'Absent', 'absent']`

An enumerated value that describes if the WSUS cleanup task exists. Present {default}   Absent    

##### <a name="-dsc_updateservicescleanup--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_updateservicescleanup--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_updateservicescleanup--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_updateservicescleanup--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_updateservicesserver"></a>`dsc_updateservicesserver`

The DSC UpdateServicesServer resource type.
Automatically generated from version 1.2.1

#### Properties

The following properties are available in the `dsc_updateservicesserver` type.

##### `dsc_classifications`

Data type: `Optional[Array[String]]`

Update classifications, * for all.

##### `dsc_clienttargetingmode`

Data type: `Optional[Enum['Client', 'client', 'Server', 'server']]`

An enumerated value that describes if how the Target Groups are populated. Client {default}   Server    

##### `dsc_contentdir`

Data type: `Optional[String]`

Folder for WSUS update files.

##### `dsc_languages`

Data type: `Optional[Array[String]]`

Update languages, * for all.

##### `dsc_products`

Data type: `Optional[Array[String]]`

Update products, * for all.

##### `dsc_proxyserverbasicauthentication`

Data type: `Optional[Boolean]`

Allow proxy server basic authentication.

##### `dsc_proxyservercredentialusername`

Data type: `Optional[String]`

Proxy server credential username.

##### `dsc_proxyservername`

Data type: `Optional[String]`

Proxy server to use when synchronizing, omit for no proxy.

##### `dsc_proxyserverport`

Data type: `Optional[Integer[0, 65535]]`

Proxy server port.

##### `dsc_sqlserver`

Data type: `Optional[String]`

SQL Server for the WSUS database, omit for Windows Internal Database.

##### `dsc_synchronizationsperday`

Data type: `Optional[Integer[0, 65535]]`

Synchronizations per day.

##### `dsc_synchronize`

Data type: `Optional[Boolean]`

Begin initial synchronization.

##### `dsc_synchronizeautomatically`

Data type: `Optional[Boolean]`

Synchronize automatically.

##### `dsc_synchronizeautomaticallytimeofday`

Data type: `Optional[String]`

First synchronization.

##### `dsc_updateimprovementprogram`

Data type: `Optional[Boolean]`

Join the Microsoft Update Improvement Program.

##### `dsc_upstreamservername`

Data type: `Optional[String]`

Upstream WSUS server, omit for Microsoft Update.

##### `dsc_upstreamserverport`

Data type: `Optional[Integer[0, 65535]]`

Port of upstream WSUS server.

##### `dsc_upstreamserverreplica`

Data type: `Optional[Boolean]`

Replica of upstream WSUS server.

##### `dsc_upstreamserverssl`

Data type: `Optional[Boolean]`

Use SSL with upstream WSUS server.

#### Parameters

The following parameters are available in the `dsc_updateservicesserver` type.

* [`dsc_ensure`](#-dsc_updateservicesserver--dsc_ensure)
* [`dsc_proxyservercredential`](#-dsc_updateservicesserver--dsc_proxyservercredential)
* [`dsc_psdscrunascredential`](#-dsc_updateservicesserver--dsc_psdscrunascredential)
* [`dsc_setupcredential`](#-dsc_updateservicesserver--dsc_setupcredential)
* [`dsc_timeout`](#-dsc_updateservicesserver--dsc_timeout)
* [`name`](#-dsc_updateservicesserver--name)
* [`validation_mode`](#-dsc_updateservicesserver--validation_mode)

##### <a name="-dsc_updateservicesserver--dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'present', 'Absent', 'absent']`

An enumerated value that describes if WSUS is configured. Present {default}   Absent    

##### <a name="-dsc_updateservicesserver--dsc_proxyservercredential"></a>`dsc_proxyservercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Proxy server credential, omit for anonymous.

##### <a name="-dsc_updateservicesserver--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_updateservicesserver--dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the initial configuration.

##### <a name="-dsc_updateservicesserver--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_updateservicesserver--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_updateservicesserver--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

